package autowrite;

import gui.CoordinatePanel;
import gui.HeadFrame;
import divisionizer.Main;
import java.awt.*;
import java.util.ArrayList;
import java.util.ResourceBundle;


public class Autowriter implements Runnable {
  
  private CoordinatePanel coordinatePanel;
  private ArrayList<String> lines;
  
  private Thread thread = null;
  private Robotti robot;
  private volatile boolean stop = false;
  private int delay = 1000;
  
  private ResourceBundle bundle = ResourceBundle.getBundle("GUI");
  private HeadFrame headFrame;
  
  public Autowriter(HeadFrame _headFrame, CoordinatePanel _coordinatePanel) {
    coordinatePanel = _coordinatePanel;
    headFrame = _headFrame;
    
    try {
      robot = new Robotti();
    }catch(AWTException exc) {
      exc.printStackTrace();
    }
  }
  
  public boolean isRunning() {
    return thread != null && thread.isAlive();
  }
  
  public void run() {
    headFrame.setTitle(bundle.getString("programTitleAutowriting"));
    
    Point p = coordinatePanel.getLocation();
    robot.slowMove(p.x, p.y, 1);
    robot.clickOn(p.x, p.y);
    
    while(lines.size() > 0) {
      if(stop) {
        headFrame.setTitle(bundle.getString("programTitle"));
        headFrame.setEnabledResumeAutowrite(true);
        return;
      }
      
      String line = lines.get(0);
      lines.remove(0);
      robot.write(line);
      if(lines.size() == 0) break;
      int wait = 0;
      while(wait < delay) {
        if(stop) {
          headFrame.setTitle(bundle.getString("programTitle"));
          headFrame.setEnabledResumeAutowrite(true);
          return;
        }
        robot.delay(10);
        wait+=10;
      }
    }
    headFrame.setTitle(bundle.getString("programTitle"));
    headFrame.setEnabledResumeAutowrite(false);
  }
  
  public void setClipboardContents(String str) {
    robot.setClipboardContents(str);
  }
  
  public void stop() {
    stop = true;
  }
  
  public void write() {
    if(!coordinatePanel.isLocked()) {
      coordinatePanel.flash();
      return;
    }
    
    stop = false;
    (thread = new Thread(this)).start();
  }
  
  public void write(ArrayList<String> _lines) {
    write(_lines, 3000);
  }
  
  public void write(ArrayList<String> _lines, int _delay) {
    if(!coordinatePanel.isLocked()) {
      coordinatePanel.flash();
      return;
    }
    
    stop = false;
    delay = _delay;
    lines = _lines;
       
    (thread = new Thread(this)).start();
  }
}
