package autowrite;

import java.awt.*;
import java.awt.datatransfer.*;
import java.awt.event.*;

class Robotti
        extends Robot implements ClipboardOwner {
  
  public Robotti() throws AWTException {
    super();
  }
  
  public void clickOn(int x, int y) {
    super.mouseMove(x, y);
    super.mousePress(InputEvent.BUTTON1_MASK);
    super.mouseRelease(InputEvent.BUTTON1_MASK);
  }
  
  public Color getPixelColorAtPoint(Point p) {
    return super.getPixelColor(p.x, p.y);
  }
  
  public void leftClick() {
    super.mousePress(InputEvent.BUTTON1_MASK);
    super.mouseRelease(InputEvent.BUTTON1_MASK);
  }
  
  public void rightClick() {
    super.mousePress(InputEvent.BUTTON2_MASK);
    super.mouseRelease(InputEvent.BUTTON2_MASK);
  }
  
  public void rotate(int centerX, int centerY, int radius, int delay) {
    int x, y;
    
    for (float i = (float) (Math.PI / 2); i <= 2.5 * Math.PI; i += 0.01) {
      x = (int) (centerX - Math.cos(i) * radius);
      y = (int) (centerY - Math.sin(i) * radius);
      super.mouseMove(x, y);
      super.delay(delay);
    }
  }
  
  public void slowMove(int x, int y) {
    slowMove(x, y, 5);
  }
  
  public void slowMove(int x, int y, int delayPerPixel) {
    int distanceX, distanceY;
    int distance;
    
    Point point = MouseInfo.getPointerInfo().getLocation();
    
    distanceX = x - point.x;
    distanceY = y - point.y;
    
    distance = (Math.abs(distanceX) > Math.abs(distanceY)) ?
      Math.abs(distanceX) : Math.abs(distanceY);
    
    for (int j = 1; j <= distance; j++) {
      super.delay(delayPerPixel);
      x = (int) (point.x + (distanceX * j / distance));
      y = (int) (point.y + (distanceY * j / distance));
      super.mouseMove(x, y);
    }
  }
  
  public void write(String text) {
    write(text, 10);
  }
  
  public void write(String text, int delay) {
    setClipboardContents(text);
    
    super.keyPress(KeyEvent.VK_CONTROL);
    super.keyPress(KeyEvent.VK_V);
    super.keyRelease(KeyEvent.VK_CONTROL);
    super.delay(delay);
    super.keyPress(KeyEvent.VK_ENTER);
    
  }
  
  public void setClipboardContents(String aString) {
    StringSelection stringSelection = new StringSelection(aString);
    Clipboard clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
    clipboard.setContents(stringSelection, this);
  }
  
  public void lostOwnership(Clipboard aClipboard, Transferable aContents) {}
}
