package divisionizer;

import java.net.*;
import java.io.*;

public class PokalListe {
  
  private static final String LINE = "class=\"breadtext\"";
  
  public static ListName[] check(String path) {
    ListName[] players = new ListName[5];
    int cycle = 0;
    
    try {
      URL page = new URL(path);
      BufferedReader br = new BufferedReader(new InputStreamReader(page.
              openStream()));
      
      String name = "";
      int golds = 0, silvers = 0;
      
      String line;
      while ((line = br.readLine()) != null) {
        line = line.trim();
        if(line.contains(LINE)) {
          switch(cycle % 3) {
            case 0:
              name = line.substring(line.indexOf('>') + 1, line.lastIndexOf('<')).trim().toLowerCase();
              break;
            case 1:
              golds = getNumber(line);
              break;
            case 2:
              silvers = getNumber(line);
              players[cycle / 3] = new ListName(name, golds, silvers);
              break;
          }
          cycle++;
        }
      }
      br.close();
    }catch(Exception exc) {
      exc.printStackTrace();
    }
    return players;
  }
  
  public static int getNumber(String str) {
    int arrows = 0;
    
    StringBuilder bui = new StringBuilder();
    for(int i = 0; i < str.length(); i++) {
      char ch = str.charAt(i);
      if(ch == '<') arrows++;
      else if(ch == '>') arrows--;
      else if(Character.isDigit(ch) && arrows == 0) bui.append(ch);
    }
    try {
      return Integer.parseInt(bui.toString());
    } catch (NumberFormatException ex) {
      return 0;
    }
  }
}