package gui;

import java.io.IOException;
import java.util.*;

import java.awt.*;
import java.awt.event.*;
import javax.imageio.ImageIO;
import javax.swing.*;

public class AboutFrame
        extends JFrame implements ActionListener, Runnable {
  
  private static final String VERSION = "Version 0.80";
  private final Font font = new Font("MS Serif", Font.BOLD, 16);
  
  private String to = "Til ", liiine = "Liiine", from = " fra ",
          eliten = "liten", and = " og ", jops = "Jops";
  
  private JButton okButton = new JButton(VERSION);
  
  private Thread thread;
  
  private int c = 0, i = 0, x = 0, y = 0;
  private Point p = null;
  private FontMetrics fm;
  private boolean direction = true;
  private boolean direction2 = true;
  
  private Point location;
  private float cos = 0;
  
  private JPanel panel = new JPanel() {
    public void paintComponent(Graphics g) {
      super.paintComponent(g);
      g.setFont(font);
      fm = g.getFontMetrics();
      
      x = (getWidth() - fm.stringWidth(to + liiine + from + eliten + and + jops)) / 2;
      y = (getHeight() - fm.getHeight()) / 2 + 15;
      p = getMousePosition();
      i = 0;
      
      write(g, to, false);
      write(g, liiine, true);
      write(g, from, false);
      write(g, eliten, true);
      write(g, and, false);
      write(g, jops, true);
    }
  };
  
  public AboutFrame() {
    ResourceBundle bundle = ResourceBundle.getBundle("GUI");
    try {
      setIconImage(ImageIO.read(ClassLoader.getSystemResource("images/flag-fi-small.gif")));
    } catch (IOException ex) {
      ex.printStackTrace();
    }
    setTitle(bundle.getString("aboutFrameTitle"));
    setSize(new Dimension(300, 100));
    
    setLayout(new BorderLayout());
    add(panel, BorderLayout.CENTER);
    add(okButton, BorderLayout.SOUTH);
    
    okButton.addActionListener(this);
    
    thread = new Thread(this);
    thread.start();
    
    setAlwaysOnTop(true);
    setLocationRelativeTo(null);
    location = getLocation();
    setVisible(true);
    
  }
  
  private void write(Graphics g, String str, boolean b) {
    if (b && p != null && p.x > x && p.x < x + fm.stringWidth(str) &&
            p.y > y - fm.getHeight() && p.y < y) {
      
      if (str == liiine) {
        g.setColor(Color.red);
      } else if (str == eliten) {
        eliten = "Nuublior";
        g.setColor(Color.blue);
      } else if (str == jops) {
        jops = "Leijonamieli";
        g.setColor(Color.orange);
      }
      
      g.drawString(str, x, y);
      x += fm.stringWidth(str);
      i += str.length();
      return;
    }
    
    if (str == eliten) {
      eliten = "liten";
    }
    if (str == jops) {
      jops = "Jops";
    }
    
    for (int j = 0; j < str.length(); j++) {
      int color = c + 2 * (direction ^ direction2 ? -i : i);
      
      if (color > 255) {
        color = 510 - color;
      }
      if (color < 0) {
        color = -color;
      }
      
      String sb = str.substring(j, j + 1);
      int w = fm.stringWidth(sb);
      
      g.setColor(new Color(color, color, color));
      
      g.drawString(sb, x, y);
      
      x += w;
      i++;
    }
    
  }
  
  public void run() {
    
    while (true) {
      try {
        Thread.sleep(7);
      } catch (InterruptedException exc) {}
      
      if (direction) {
        c++;
        if (c == 255) {
          direction = false;
          direction2 = !direction2;
        }
      } else {
        c--;
        if (c == 0) {
          direction = true;
          direction2 = !direction2;
        }
      } 
      panel.repaint();
      
      cos += 0.01f;
      if(cos > 2*Math.PI) cos -= 2*Math.PI;
      setLocation(location.x + (int) (Math.cos(cos) * 100), location.y);
    }
  }
  
  public void actionPerformed(ActionEvent e) {
    this.dispose();
  }
}
