package gui;

import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import javax.imageio.ImageIO;
import javax.swing.JPanel;

public class BackgroundPanel extends JPanel {
  
  private BufferedImage bg = null;
  
  public void paintComponent(Graphics g) {
    super.paintComponent(g);
    if(bg!=null) {
      g.drawImage(bg, 0, 0, getWidth(), getHeight(), null);
    }
  }
  
  public void setBackground(Color c) {
    super.setBackground(c);
    bg = null;
  }
  
  public void setBackground(File file) {
    try {
      bg = ImageIO.read(file);
    } catch (IOException ex) {
      ex.printStackTrace();
      bg = null;
    }
  }
}
