package gui;

import java.util.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class CoordinatePanel
        extends JPanel implements KeyListener {
  
  private JLabel coordinatesLabel = new JLabel();
  JTextField popupField = new JTextField(ResourceBundle.getBundle("GUI").
          getString("lockCoordinates"));
  
  private Point point = new Point();
  private boolean running = true;
  
  public CoordinatePanel() {
    add(coordinatesLabel);
    addKeyListener(this);
    update();
    new java.util.Timer().schedule(new CoordinateTimerTask(), 0, 10);
  }
  
  public void flash() {
    ( (new Thread() {
      public void run() {
        try {
          
          Point p = coordinatesLabel.getLocationOnScreen();
          
          Popup pop = PopupFactory.getSharedInstance().getPopup(
                  coordinatesLabel, popupField, p.x, p.y + 20);
          pop.show();
          Color bg = coordinatesLabel.getBackground();
          for (int i = 0; i < 3; i++) {
            setBackground(Color.red);
            Thread.sleep(100);
            setBackground(bg);
            Thread.sleep(100);
          }
          Thread.sleep(2000);
          pop.hide();
        } catch (InterruptedException exc) {}
        update();
      }
    })).start();
  }
  
  public Point getLocation() {
    return point.getLocation();
  }
  
  public boolean isLocked() {
    return!running;
  }
  
  public void keyPressed(KeyEvent e) {
    if (e.getKeyCode() == KeyEvent.VK_F1) {
      running = !running;
      update();
    }
  }
  
  public void keyReleased(KeyEvent e) {}
  
  public void keyTyped(KeyEvent e) {}
  
  private class CoordinateTimerTask
          extends TimerTask {
    public void run() {
      if (running) {
        point = MouseInfo.getPointerInfo().getLocation();
        coordinatesLabel.setText(" " + point.x + ", " + point.y);
      }
    }
  }
  
  public void update() {
    coordinatesLabel.setFont(new Font("Dialog", running ? 0 : 1, 12));
    setBorder(running ? BorderFactory.createRaisedBevelBorder() :
      BorderFactory.createLoweredBevelBorder());
    
  }
}
